
import java.util.TreeMap;
import java.util.Enumeration;
import java.util.Vector;

class DictTable extends Common
{
  private TreeMap tree = new TreeMap ();
  private Vector  list = new Vector ();

  public DictItem get (String ident)
  {
    return (DictItem) tree.get (ident);
  }

  public boolean contains (String ident)
  {
     return tree.containsKey (ident);
  }

  public void store (DictItem item)
  {
    if (item == null)
       err ("Null item");

    if (empty (item.ident))
       err ("Empty name");

    if (contains (item.ident))
       err ("Item already defined: " + item.ident);

    tree.put (item.ident, item);
    list.add (item);
  }

  public Enumeration elements ()
  {
    return list.elements ();
  }

  public int size ()
  {
    return tree.size ();
  }
}
