
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

class Dump extends Tool
{

  /* output */

  private void check (String expr)
  {
    println ("assert (" + expr + ");");
  }

  /* enumerations */

  private String decl_conv (TypeInfo t)
  {
     return "string conv_" + t.ident +
            " (" + t.decl() + " item" + ")";
  }

  private void conv_enumeration (EnumInfo e)
  {
     println (decl_conv (e));
     println ("{");
     indent ++;

     /*
     Enumeration items = e.getItems ();
     int count = 0;
     while (items.hasMoreElements ())
     {
        DictItem item = (DictItem) items.nextElement ();

        count ++;
        if (count != 1) print ("else ");

        println ("if (item == " + item.ident + ")");
        indent ++;
        println ("return " + '"' + item.ident + '"' + ';');
        indent --;
     }

     if (count > 1) print ("else ");
     check ("false");
     */

     println ("switch (item)");
     println ("{");
     indent ++;

     Enumeration items = e.getItems ();
     while (items.hasMoreElements ())
     {
        DictItem item = (DictItem) items.nextElement ();

        println ("case " + item.ident + ":");
        indent ++;
        println ("return " + '"' + item.ident + '"' + "; ");
        println ("break;");
        indent --;
     }

     println ("default: ");
     indent ++;
     check ("false");
     indent --;

     indent --;
     println ("}");

     indent --;
     println ("}");
     println ("");
  }

  /* structures */

  private void produce_attributes (StructInfo s)
  {
     println ("void " + s.ident + "::produce_attributes ()");
     println ("{");
     indent ++;

     // super class
     if (s.from != null)
        println (s.from.ident + "::produce_attributes ();");

     // fields
     Enumeration fields = s.getFields ();
     while (fields.hasMoreElements ())
     {
        FieldInfo f = (FieldInfo) fields.nextElement ();

        if (f.type instanceof EnumInfo)
        {
           print ("store_ident");
        }
        else if (f.type instanceof StructInfo)
        {
           print ("store_item");
        }
        else
        {
           print ("store_" + f.type.ident);
        }

        print (" (");

        print ('"' + f.ident + '"');
        print (", ");

        if (f.type instanceof EnumInfo)
        {
           print ("conv_" + f.type.ident + " (this->" + f.ident + ")");
        }
        else
        {
           print ("this->" + f.ident);
        }

        println (");");
     }

     indent --;
     println ("}");
     println ("");
  }

  private void produce_sequence (StructInfo s)
  {
     println ("void " + s.ident + "::produce_sequence ()");
     println ("{");
     indent ++;

     println (s.sequence.decl() + " subitem = this->first;");

     println ("while (subitem != NULL)");
     println ("{");
     indent ++;

     println ("insert_item (subitem);");
     println ("subitem = subitem->next;");

     indent --;
     println ("}");

     indent --;
     println ("}");
     println ("");
  }

  /* local headers */

  public void local_headers ()
  {
     Enumeration seq = info.getTypes ();
     while (seq.hasMoreElements ())
     {
        TypeInfo t = (TypeInfo) seq.nextElement ();
        if (t instanceof EnumInfo)
        {
           println (decl_conv (t) + ";");
        }
     }
     println ("");
  }

  /* code */

  public void sendCode ()
  {
     local_headers ();

     Enumeration seq = info.getTypes ();
     while (seq.hasMoreElements ())
     {
        TypeInfo t = (TypeInfo) seq.nextElement ();
        if (t instanceof EnumInfo)
        {
           EnumInfo e = (EnumInfo) t;
           conv_enumeration (e);
        }
        else if (t instanceof StructInfo)
        {
           StructInfo s = (StructInfo) t;

           if (s.getFieldCount () != 0)
              produce_attributes (s);

           if (s.sequence != null)
              produce_sequence (s);
        }
     }
  }

}
