
import antlr.CommonAST;
import java.util.Enumeration;

class RuleNode extends CommonAST
{
  public String name;
  public int mode;
  public TypeInfo type;

  public String unary_tag; // tag for <unary> rule
  public TypeInfo temp_type;   // type of <tmp> sub-rule
  public RuleNode stored_rule; // <tmp> or anonymous sub-rule

  public Context context;
  public int context_count;

  public boolean custom_send; // user defined send_... function

  private DictTable dict = new DictTable ();

  public String addVariable (String name, String type)
  {
     String s = name;
     int i = 0;
     while (dict.contains (s))
     {
        i ++;
        s = name + i;
     }

     VarInfo item = new VarInfo ();
     item.ident = s;
     item.type = type;
     dict.store (item);

     return s;
  }

  public Enumeration getVariables ()
  {
     return dict.elements ();
  }

}
