
class Test extends Tool
{
  // private int indent;

  private void send (String s)
  {
     // for (int i = 0; i < indent; i++) print ("  ");
     println (s);
  }

  /* grammar */

  public void openStruct(String type_name)
  {
     super.openStruct (type_name);
     send ("Struct " + type_name);
     indent ++;
  }

  public void closeStruct ()
  {
     super.closeStruct ();

     indent --;
     send ("End of struct");
  }

  public void structField (String name, String type)
  {
     super.structField (name, type);
     send ("field " + name + " : " + type);
  }

  public void structSequence (String name, String type)
  {
     super.structSequence (name, type);
     send ("sequence " + name + " : " + type);
  }

  public void addTag (String type_name,
                      String tag_name,
                      String tag_value)
  {
     super.addTag (type_name, tag_name, tag_value);
     send ("type name = " + type_name);
     indent ++;
     send ("tag name = " + tag_name);
     send ("tag value = " + tag_value);
     indent --;
  }

  public void addSuper (String type_name,
                        String super_name)
  {
     super.addSuper (type_name, super_name);
     send ("type name = " + type_name);
     indent ++;
     send ("super type = " + super_name);
     indent --;
  }

  public void addCustom (String type_name, String key)
  {
     super.addCustom (type_name, key);
     send ("type name = " + type_name);
     indent ++;
     send ("custom " + key);

     indent --;
  }

  public void openEnum (String name)
  {
     super.openEnum (name);
     send ("Enum " + name);
     indent ++;
  }

  public void closeEnum ()
  {
     super.closeEnum ();


     indent --;
     send ("End of enum");
  }

  public void enumItem (String name)
  {
     super.enumItem (name);
     send ("item " + name);
  }

  public void literal (String name, String value)
  {
     super.literal (name, value);
     send ("literal " + name + " = " + value);
  }

  public void option (String name, String value)
  {
     super.option (name, value);
     send ("option " + name + " = " + value);
  }

  public void openClass (String name)
  {
     super.openClass (name);
     send ("Class " + name);
     indent ++;
  }

  public void closeClass ()
  {
     super.closeClass ();
     indent --;
     send ("End of class");
  }

  public void openRule (String name)
  {
     super.openRule (name);
     send ("Rule " + name);
     indent ++;
  }

  public void ruleParam (int mode,
                         String type_name)
  {
     super.ruleParam (mode, type_name);
     send ("Param " + type_name);
  }

  public void closeRule ()
  {
     super.closeRule ();
     indent --;
     send ("End of rule");
  }

  public void openBinary (String branch)
  {
     super.openBinary (branch);
     send ("Binary");
     indent ++;
  }

  public void binaryItem (String key, String tag_value)
  {
     super.binaryItem (key, tag_value);
     send ("item " + key + " " + tag_value);
  }

  public void closeBinary ()
  {
     super.closeBinary ();
     indent --;
  }

  public void unary (String key, String tag_value, String branch)
  {
     super.unary (key, tag_value, branch);
     send ("Unary " + key + " " + tag_value + " " + branch);
  }

  public void openPrimitive ()
  {
     super.openPrimitive ();
     send ("Primitive");
     indent ++;
  }

  public void primitiveItem (String branch)
  {
     super.primitiveItem (branch);
     send ("item " + branch);
  }

  public void closePrimitive ()
  {
     super.closePrimitive ();
     indent --;
  }

  public void openChooseBlock ()
  {
     super.openChooseBlock ();
     send ("open choose block");
  }

  public void closeChooseBlock ()
  {
     super.closeChooseBlock ();
     send ("close choose block");
  }

  /*
  public void openChooseAlternative ()
  {
     super.openChooseAlternative ();
     send ("open choose alternative");
  }


  public void closeChooseAlternative ()
  {
     super.closeChooseAlternative ();
     send ("close choose alternative");
  }
  */

  public void openBlock ()
  {
     super.openBlock ();
     send ("Block");
     indent ++;
  }

  public void closeBlock ()
  {
     super.closeBlock ();
     indent --;
     send ("End of block");
  }

  public void openAlternative ()
  {
     super.openAlternative ();
     send ("Alternative");
     indent ++;
  }

  public void closeAlternative ()
  {
     super.closeAlternative ();
     indent --;

     send ("End of alternative");
  }

  public void terminal (String name)
  {
     super.terminal (name);
     send ("Terminal " + name);
  }

  public void nonterminal (int kind, String label, String name)
  {
     super.nonterminal (kind, label, name);

     String txt = name;

     if (kind == LABELED) txt = label + " : " + txt;
     if (kind == ADD) txt = "<add> " + txt;
     if (kind == CALL) txt = "<call> " + txt;
     if (kind == TMP) txt = "<tmp> " + txt;

     send ("Nonterminal " + txt);
  }

  public void openPredicate ()
  {
     super.openPredicate ();
     send ("Predicate");
     indent ++;
  }

  public void closePredicate ()
  {
     super.closePredicate ();
     indent --;
     send ("End of predicate");
  }

  public void predicateNonterminal (String name)
  {
     super.predicateNonterminal (name);
     send ("Predicate nonterminal " + name);
  }

  public void predicateTerminal (String name)
  {
     super.predicateTerminal (name);
     send ("Predicate terminal " + name);
  }

  public void resultOption (String type_name)
  {
     super.resultOption (type_name);

     send ("Result " + type_name);
  }

  public void storeOption (String name)
  {
     super.storeOption (name);
     send ("Store " + name);
  }

  public void setOption (String name, String value)
  {
     super.setOption (name, value);
     send ("Set " + name + " = " + value);
  }

  public void silentOption ()
  {
     super.silentOption ();
     send ("Silent");
  }

  public void styleOption (int style)
  {
     super.styleOption (style);

     String txt = "";
     switch (style)

     {
        case SPACE:     txt = "space";     break;
        case NOSPACE:   txt = "nospace";   break;
        case NEWLINE:   txt = "newline";   break;
        case EMPTY:     txt = "empty";     break;
        case INDENT:    txt = "indent";    break;
        case UNINDENT:  txt = "unindent";  break;
     }
     send ("Style " + txt);
  }

}
