
// Whitespace -- ignored
WS :
  ( ' '
  |	'\t'
	|	'\f'
	|	(	"\r\n"  // DOS
	 	|	'\r'    // Macintosh
	  |	'\n'    // Unix
		)
  	{ newline(); }
	)
	{ _ttype = ANTLR_USE_NAMESPACE(antlr)Token::SKIP; }
  ;

COMMENT_1 :
  "(*"
  (
    options { generateAmbigWarnings=false; }:

  	{ LA(2) != ')' }? '*'
	  |	'\r' '\n'		{ newline(); }
	  |	'\r'			  { newline(); }
	  |	'\n'			  { newline(); }
    |   ~('*' | '\n' | '\r')

  )*
  "*)"
	{$setType(ANTLR_USE_NAMESPACE(antlr)Token::SKIP);}
	;

COMMENT_2 :
  '{'
	 (
	    options { generateAmbigWarnings=false; }:
	
	      '\r' '\n' { newline(); }
		  |	'\r'			{ newline(); }
		  |	'\n'			{ newline(); }
      |  ~('}' | '\n' | '\r')
  )*
  '}'
	{$setType(ANTLR_USE_NAMESPACE(antlr)Token::SKIP);}
	;

// an identifier.  Note that testLiterals is set to true!  This means
// that after we match the rule, we look in the literals table to see
// if it's a literal or really an identifer
IDENT
	options { testLiterals=true; }:
	('a'..'z') ('a'..'z'|'0'..'9')*
	;

// string literals
STRING_LITERAL
	: '\'' ( "\'\'" | ~('\'') )+ '\''
	;

// a numeric literal
NUM_INT :
	('0'..'9') ('0'..'9')*
		
	// only check to see if it's a float if looks like decimal so far
	(	{ LA(2)!='.' && LA(3)!='.' }?
		(	
		  '.' ('0'..'9')* (EXPONENT)?
	  |	
		  EXPONENT
		)
		{ _ttype = NUM_REAL; }
	)?
	;

// a couple protected methods to assist in matching floating point numbers
protected
EXPONENT
	:	('e') ('+'|'-')? ('0'..'9')+
	;
	