
class TinyParser;

/* --------------------------------------------------------------------- */	

struct_decl <TStructDecl>:
  "class"
  name:identifier
  '{'
  ( <add> member_decl )*
  '}' ;

member_decl <TStructDecl>:
   type_name:identifier
   name:identifier
   ';' ;

/* --------------------------------------------------------------------- */	

struct_value <TStructValue>:
  type_name:identifier
  '{'
  ( <add> field_value )*
  '}' ;

field_value <TFieldValue>:
  name:identifier
  (
    '=' (
          simple_val:simple_value ';'
        |
          struct_val:struct_value (';')?
        |
          block_val:block_value (';')?
        )
  |
    ':' insert_val:struct_value (';')?
  );

block_value <TBlockValue>:
  '{'
  ( <add> struct_value )*
  '}' ;

simple_value <TSimpleValue>:
    ident_value:qualified_identifier
  | string_value:string;

qualified_identifier <TQualIdent>:
   <add> qual_ident_item ('.' <add> qual_ident_item) ;

qual_ident_item <TQualIdentItem>:
   name:identifier;

/* --------------------------------------------------------------------- */	

identifier <literal>: IDENT ;
string <literal>: STR ;
